Computation of FFT with CUFFT on HDF5 file.

# Requirements

- cmake > 3
- make
- g++ 11
- HDF5 C++
- NVidia HPC_SDK (22.11)

# Compilation and use

```sh
cd CUFFT_HDF5
mkdir build
cd build
cmake ..
make
```

With environnement variables **CC**, **CXX** set **C** and **C++**.
It is also possible to define **NVCPP** to use **nvc++** instead of **g++** or **clang++**.

The **HPC_SDK** **cmake** path can be defined with :
```
export NVHPC_CMAKE_MODULES="/opt/nvidia/hpc_sdk/Linux_x86_64/22.11/cmake/"
```

# Programs

- **create_hdf5_normal_distribution** : creates **HDF5** file filled with random normal distribution
- **compute_cufft_on_hdf5** : performs the **FFT** on the **HDF5** input file with a certain number of batch
